library(frbs)
library(batch)
seed <- 101
set.seed(seed)
library(C50)
## Start input data
load("iris.5f.RData")

tra.iris.1 <- data.frame(iris.5.1.tra)
tra.iris.2 <- data.frame(iris.5.2.tra)
tra.iris.3 <- data.frame(iris.5.3.tra)
tra.iris.4 <- data.frame(iris.5.4.tra)
tra.iris.5 <- data.frame(iris.5.5.tra)
					

tst.iris.1 <- data.frame(iris.5.1.tst[, -ncol(iris.5.1.tst)])
tst.iris.2 <- data.frame(iris.5.2.tst[, -ncol(iris.5.1.tst)])
tst.iris.3 <- data.frame(iris.5.3.tst[, -ncol(iris.5.1.tst)])
tst.iris.4 <- data.frame(iris.5.4.tst[, -ncol(iris.5.1.tst)])
tst.iris.5 <- data.frame(iris.5.5.tst[, -ncol(iris.5.1.tst)])

real.iris.1 <- data.frame(matrix(iris.5.1.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.2 <- data.frame(matrix(iris.5.2.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.3 <- data.frame(matrix(iris.5.3.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.4 <- data.frame(matrix(iris.5.4.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.5 <- data.frame(matrix(iris.5.5.tst[, ncol(iris.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
 object.C50.1 <- C5.0(x = tra.iris.1[, -ncol(tra.iris.1)], y = as.factor(tra.iris.1[, ncol(tra.iris.1)]), trials = 100)
 object.C50.2 <- C5.0(x = tra.iris.2[, -ncol(tra.iris.2)], y = as.factor(tra.iris.2[, ncol(tra.iris.2)]), trials = 100)
 object.C50.3 <- C5.0(x = tra.iris.3[, -ncol(tra.iris.3)], y = as.factor(tra.iris.3[, ncol(tra.iris.3)]), trials = 100)
 object.C50.4 <- C5.0(x = tra.iris.4[, -ncol(tra.iris.4)], y = as.factor(tra.iris.4[, ncol(tra.iris.4)]), trials = 100)
 object.C50.5 <- C5.0(x = tra.iris.5[, -ncol(tra.iris.5)], y = as.factor(tra.iris.5[, ncol(tra.iris.5)]), trials = 100)

pred.1 <- matrix(c(predict(object.C50.1, tst.iris.1)))
pred.2 <- matrix(c(predict(object.C50.2, tst.iris.2)))
pred.3 <- matrix(c(predict(object.C50.3, tst.iris.3)))
pred.4 <- matrix(c(predict(object.C50.4, tst.iris.4)))
pred.5 <- matrix(c(predict(object.C50.5, tst.iris.5)))

err.1 = 100*sum(real.iris.1!=pred.1)/nrow(pred.1)
err.2 = 100*sum(real.iris.2!=pred.2)/nrow(pred.2)
err.3 = 100*sum(real.iris.3!=pred.3)/nrow(pred.3)
err.4 = 100*sum(real.iris.4!=pred.4)/nrow(pred.4)
err.5 = 100*sum(real.iris.5!=pred.5)/nrow(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)