library(frbs)
library(batch)
library(kernlab)
seed <- 101
set.seed(seed)

## Start input data
load("iris.5f.RData")

tra.iris.1 <- data.frame(iris.5.1.tra)
tra.iris.2 <- data.frame(iris.5.2.tra)
tra.iris.3 <- data.frame(iris.5.3.tra)
tra.iris.4 <- data.frame(iris.5.4.tra)
tra.iris.5 <- data.frame(iris.5.5.tra)
names.attrs <- c("Sepal.Length", "Sepal.Width", "Petal.Length",
                            "Petal.Width", "Species")
colnames(tra.iris.1) <- names.attrs
colnames(tra.iris.2) <- names.attrs
colnames(tra.iris.3) <- names.attrs
colnames(tra.iris.4) <- names.attrs
colnames(tra.iris.5) <- names.attrs
							

tst.iris.1 <- data.frame(iris.5.1.tst[, 1 : 4])
tst.iris.2 <- data.frame(iris.5.2.tst[, 1 : 4])
tst.iris.3 <- data.frame(iris.5.3.tst[, 1 : 4])
tst.iris.4 <- data.frame(iris.5.4.tst[, 1 : 4])
tst.iris.5 <- data.frame(iris.5.5.tst[, 1 : 4])
names.outattr <- c("Sepal.Length", "Sepal.Width", "Petal.Length",
                            "Petal.Width")
colnames(tst.iris.1) <- names.outattr
colnames(tst.iris.2) <- names.outattr
colnames(tst.iris.3) <- names.outattr
colnames(tst.iris.4) <- names.outattr
colnames(tst.iris.5) <- names.outattr

real.iris.1 <- data.frame(matrix(iris.5.1.tst[, 5], ncol = 1))
real.iris.2 <- data.frame(matrix(iris.5.2.tst[, 5], ncol = 1))
real.iris.3 <- data.frame(matrix(iris.5.3.tst[, 5], ncol = 1))
real.iris.4 <- data.frame(matrix(iris.5.4.tst[, 5], ncol = 1))
real.iris.5 <- data.frame(matrix(iris.5.5.tst[, 5], ncol = 1))

## generate model using classification SVM with default parameters (for simplicity).
object.SVM.1 <- ksvm(Species ~., data = tra.iris.1, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.2 <- ksvm(Species ~., data = tra.iris.2, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.3 <- ksvm(Species ~., data = tra.iris.3, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.4 <- ksvm(Species ~., data = tra.iris.4, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.5 <- ksvm(Species ~., data = tra.iris.5, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)

pred.1 <- as.matrix(predict(object.SVM.1, tst.iris.1))
pred.2 <- as.matrix(predict(object.SVM.2, tst.iris.2))
pred.3 <- as.matrix(predict(object.SVM.3, tst.iris.3))
pred.4 <- as.matrix(predict(object.SVM.4, tst.iris.4))
pred.5 <- as.matrix(predict(object.SVM.5, tst.iris.5))

err.1 = 100*sum(real.iris.1!=pred.1)/nrow(real.iris.1)
err.2 = 100*sum(real.iris.2!=pred.2)/nrow(real.iris.2)
err.3 = 100*sum(real.iris.3!=pred.3)/nrow(real.iris.3)
err.4 = 100*sum(real.iris.4!=pred.4)/nrow(real.iris.4)
err.5 = 100*sum(real.iris.5!=pred.5)/nrow(real.iris.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 +err.5)/5
print(err.aver)