library(frbs)
library(batch)
library(nnet)
seed <- 101
set.seed(seed)

## Start input data
load("iris.5f.RData")

tra.iris.1 <- data.frame(iris.5.1.tra)
tra.iris.2 <- data.frame(iris.5.2.tra)
tra.iris.3 <- data.frame(iris.5.3.tra)
tra.iris.4 <- data.frame(iris.5.4.tra)
tra.iris.5 <- data.frame(iris.5.5.tra)

target.iris.1 <- class.ind(tra.iris.1[, ncol(tra.iris.1)])
target.iris.2 <- class.ind(tra.iris.2[, ncol(tra.iris.2)])
target.iris.3 <- class.ind(tra.iris.3[, ncol(tra.iris.3)])
target.iris.4 <- class.ind(tra.iris.4[, ncol(tra.iris.4)])
target.iris.5 <- class.ind(tra.iris.5[, ncol(tra.iris.5)])

tst.iris.1 <- data.frame(iris.5.1.tst[, -ncol(iris.5.1.tst)])
tst.iris.2 <- data.frame(iris.5.2.tst[, -ncol(iris.5.1.tst)])
tst.iris.3 <- data.frame(iris.5.3.tst[, -ncol(iris.5.1.tst)])
tst.iris.4 <- data.frame(iris.5.4.tst[, -ncol(iris.5.1.tst)])
tst.iris.5 <- data.frame(iris.5.5.tst[, -ncol(iris.5.1.tst)])

real.iris.1 <- iris.5.1.tst[, ncol(iris.5.1.tst)]
real.iris.2 <- iris.5.2.tst[, ncol(iris.5.1.tst)]
real.iris.3 <- iris.5.3.tst[, ncol(iris.5.1.tst)]
real.iris.4 <- iris.5.4.tst[, ncol(iris.5.1.tst)]
real.iris.5 <- iris.5.5.tst[, ncol(iris.5.1.tst)]


iris.nnet.1 <- nnet(x = tra.iris.1[, -ncol(tra.iris.1)], y = target.iris.1, 
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
iris.nnet.2 <- nnet(x = tra.iris.2[, -ncol(tra.iris.2)], y = target.iris.2, 
					size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
iris.nnet.3 <- nnet(x = tra.iris.3[, -ncol(tra.iris.3)], y = target.iris.3,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
iris.nnet.4 <- nnet(x = tra.iris.4[, -ncol(tra.iris.4)], y = target.iris.4,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
iris.nnet.5 <- nnet(x = tra.iris.5[, -ncol(tra.iris.5)], y = target.iris.5,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)

				
iris.p.1<-predict(iris.nnet.1, tst.iris.1)
iris.p.2<-predict(iris.nnet.2, tst.iris.2)
iris.p.3<-predict(iris.nnet.3, tst.iris.3)
iris.p.4<-predict(iris.nnet.4, tst.iris.4)
iris.p.5<-predict(iris.nnet.5, tst.iris.5)

err.1 = 100*sum(as.numeric(real.iris.1)!=max.col(iris.p.1))/length(real.iris.1)
err.2 = 100*sum(as.numeric(real.iris.2)!=max.col(iris.p.2))/length(real.iris.2)
err.3 = 100*sum(as.numeric(real.iris.3)!=max.col(iris.p.3))/length(real.iris.3)
err.4 = 100*sum(as.numeric(real.iris.4)!=max.col(iris.p.4))/length(real.iris.4)
err.5 = 100*sum(as.numeric(real.iris.5)!=max.col(iris.p.5))/length(real.iris.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 +err.5)/5
print(err.aver)
