library(frbs)
library(batch)
library(randomForest)
seed <- 101
set.seed(seed)

## Start input data
load("iris.5f.RData")

tra.iris.1 <- data.frame(iris.5.1.tra)
tra.iris.2 <- data.frame(iris.5.2.tra)
tra.iris.3 <- data.frame(iris.5.3.tra)
tra.iris.4 <- data.frame(iris.5.4.tra)
tra.iris.5 <- data.frame(iris.5.5.tra)
names.attrs <- c("Sepal.Length", "Sepal.Width", "Petal.Length",
                "Petal.Width", "Species")
colnames(tra.iris.1) <- names.attrs
colnames(tra.iris.2) <- names.attrs
colnames(tra.iris.3) <- names.attrs
colnames(tra.iris.4) <- names.attrs
colnames(tra.iris.5) <- names.attrs
							

tst.iris.1 <- data.frame(iris.5.1.tst[, -ncol(iris.5.1.tst)])
tst.iris.2 <- data.frame(iris.5.2.tst[, -ncol(iris.5.1.tst)])
tst.iris.3 <- data.frame(iris.5.3.tst[, -ncol(iris.5.1.tst)])
tst.iris.4 <- data.frame(iris.5.4.tst[, -ncol(iris.5.1.tst)])
tst.iris.5 <- data.frame(iris.5.5.tst[, -ncol(iris.5.1.tst)])
names.outattr <- c("Sepal.Length", "Sepal.Width", "Petal.Length",
                            "Petal.Width")
colnames(tst.iris.1) <- names.outattr
colnames(tst.iris.2) <- names.outattr
colnames(tst.iris.3) <- names.outattr
colnames(tst.iris.4) <- names.outattr
colnames(tst.iris.5) <- names.outattr

real.iris.1 <- data.frame(matrix(iris.5.1.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.2 <- data.frame(matrix(iris.5.2.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.3 <- data.frame(matrix(iris.5.3.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.4 <- data.frame(matrix(iris.5.4.tst[, ncol(iris.5.1.tst)], ncol = 1))
real.iris.5 <- data.frame(matrix(iris.5.5.tst[, ncol(iris.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
object.rF.1 <- randomForest(Species ~., tra.iris.1, importance =TRUE, proximity = TRUE)
object.rF.2 <- randomForest(Species ~., tra.iris.2, importance =TRUE, proximity = TRUE)
object.rF.3 <- randomForest(Species ~., tra.iris.3, importance =TRUE, proximity = TRUE)
object.rF.4 <- randomForest(Species ~., tra.iris.4, importance =TRUE, proximity = TRUE)
object.rF.5 <- randomForest(Species ~., tra.iris.5, importance =TRUE, proximity = TRUE)

pred.1 <- predict(object.rF.1, tst.iris.1)
pred.2 <- predict(object.rF.2, tst.iris.2)
pred.3 <- predict(object.rF.3, tst.iris.3)
pred.4 <- predict(object.rF.4, tst.iris.4)
pred.5 <- predict(object.rF.5, tst.iris.5)

err.1 = 100*sum(real.iris.1!=round(pred.1))/nrow(real.iris.1)
err.2 = 100*sum(real.iris.2!=round(pred.2))/nrow(real.iris.2)
err.3 = 100*sum(real.iris.3!=round(pred.3))/nrow(real.iris.3)
err.4 = 100*sum(real.iris.4!=round(pred.4))/nrow(real.iris.4)
err.5 = 100*sum(real.iris.5!=round(pred.5))/nrow(real.iris.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)