library(C50)
library(frbs)
library(batch)
seed <- 101
set.seed(seed)
## Start input data
load("pima.5f.RData")
tra.pima.1 <- data.frame(pima.5.1.tra)
tra.pima.2 <- data.frame(pima.5.2.tra)
tra.pima.3 <- data.frame(pima.5.3.tra)
tra.pima.4 <- data.frame(pima.5.4.tra)
tra.pima.5 <- data.frame(pima.5.5.tra)
					
tst.pima.1 <- data.frame(pima.5.1.tst[, -ncol(pima.5.1.tst)])
tst.pima.2 <- data.frame(pima.5.2.tst[, -ncol(pima.5.1.tst)])
tst.pima.3 <- data.frame(pima.5.3.tst[, -ncol(pima.5.1.tst)])
tst.pima.4 <- data.frame(pima.5.4.tst[, -ncol(pima.5.1.tst)])
tst.pima.5 <- data.frame(pima.5.5.tst[, -ncol(pima.5.1.tst)])

real.pima.1 <- data.frame(matrix(pima.5.1.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.2 <- data.frame(matrix(pima.5.2.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.3 <- data.frame(matrix(pima.5.3.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.4 <- data.frame(matrix(pima.5.4.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.5 <- data.frame(matrix(pima.5.5.tst[, ncol(pima.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
 object.C50.1 <- C5.0(x = tra.pima.1[, -ncol(tra.pima.1)], y = as.factor(tra.pima.1[, ncol(tra.pima.1)]), trials = 100)
 object.C50.2 <- C5.0(x = tra.pima.2[, -ncol(tra.pima.2)], y = as.factor(tra.pima.2[, ncol(tra.pima.2)]), trials = 100)
 object.C50.3 <- C5.0(x = tra.pima.3[, -ncol(tra.pima.3)], y = as.factor(tra.pima.3[, ncol(tra.pima.3)]), trials = 100)
 object.C50.4 <- C5.0(x = tra.pima.4[, -ncol(tra.pima.4)], y = as.factor(tra.pima.4[, ncol(tra.pima.4)]), trials = 100)
 object.C50.5 <- C5.0(x = tra.pima.5[, -ncol(tra.pima.5)], y = as.factor(tra.pima.5[, ncol(tra.pima.5)]), trials = 100)

pred.1 <- matrix(c(predict(object.C50.1, tst.pima.1)))
pred.2 <- matrix(c(predict(object.C50.2, tst.pima.2)))
pred.3 <- matrix(c(predict(object.C50.3, tst.pima.3)))
pred.4 <- matrix(c(predict(object.C50.4, tst.pima.4)))
pred.5 <- matrix(c(predict(object.C50.5, tst.pima.5)))

err.1 = 100*sum(real.pima.1!=pred.1)/nrow(pred.1)
err.2 = 100*sum(real.pima.2!=pred.2)/nrow(pred.2)
err.3 = 100*sum(real.pima.3!=pred.3)/nrow(pred.3)
err.4 = 100*sum(real.pima.4!=pred.4)/nrow(pred.4)
err.5 = 100*sum(real.pima.5!=pred.5)/nrow(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)