library(kernlab)
library(frbs)
library(batch)
seed <- 101
set.seed(seed)
## Start input data
load("pima.5f.RData")
tra.pima.1 <- data.frame(pima.5.1.tra)
tra.pima.2 <- data.frame(pima.5.2.tra)
tra.pima.3 <- data.frame(pima.5.3.tra)
tra.pima.4 <- data.frame(pima.5.4.tra)
tra.pima.5 <- data.frame(pima.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9")
colnames(tra.pima.1) <- names.attrs
colnames(tra.pima.2) <- names.attrs
colnames(tra.pima.3) <- names.attrs
colnames(tra.pima.4) <- names.attrs
colnames(tra.pima.5) <- names.attrs
							

tst.pima.1 <- data.frame(pima.5.1.tst[, 1 : 8])
tst.pima.2 <- data.frame(pima.5.2.tst[, 1 : 8])
tst.pima.3 <- data.frame(pima.5.3.tst[, 1 : 8])
tst.pima.4 <- data.frame(pima.5.4.tst[, 1 : 8])
tst.pima.5 <- data.frame(pima.5.5.tst[, 1 : 8])
names.outattr <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8")
colnames(tst.pima.1) <- names.outattr
colnames(tst.pima.2) <- names.outattr
colnames(tst.pima.3) <- names.outattr
colnames(tst.pima.4) <- names.outattr
colnames(tst.pima.5) <- names.outattr


real.pima.1 <- data.frame(matrix(pima.5.1.tst[, 9], ncol = 1))
real.pima.2 <- data.frame(matrix(pima.5.2.tst[, 9], ncol = 1))
real.pima.3 <- data.frame(matrix(pima.5.3.tst[, 9], ncol = 1))
real.pima.4 <- data.frame(matrix(pima.5.4.tst[, 9], ncol = 1))
real.pima.5 <- data.frame(matrix(pima.5.5.tst[, 9], ncol = 1))

## generate model using classification SVM with default parameters (for simplicity).
object.SVM.1 <- ksvm(c9 ~., data = tra.pima.1, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.2 <- ksvm(c9 ~., data = tra.pima.2, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.3 <- ksvm(c9 ~., data = tra.pima.3, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.4 <- ksvm(c9 ~., data = tra.pima.4, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)
object.SVM.5 <- ksvm(c9 ~., data = tra.pima.5, type = "C-bsvc", kernel = "rbfdot", kpar = list(sigma = 0.1), C= 10, prob.model = TRUE)

pred.1 <- as.matrix(predict(object.SVM.1, tst.pima.1))
pred.2 <- as.matrix(predict(object.SVM.2, tst.pima.2))
pred.3 <- as.matrix(predict(object.SVM.3, tst.pima.3))
pred.4 <- as.matrix(predict(object.SVM.4, tst.pima.4))
pred.5 <- as.matrix(predict(object.SVM.5, tst.pima.5))

err.1 = 100*sum(real.pima.1!=pred.1)/nrow(real.pima.1)
err.2 = 100*sum(real.pima.2!=pred.2)/nrow(real.pima.2)
err.3 = 100*sum(real.pima.3!=pred.3)/nrow(real.pima.3)
err.4 = 100*sum(real.pima.4!=pred.4)/nrow(real.pima.4)
err.5 = 100*sum(real.pima.5!=pred.5)/nrow(real.pima.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 +err.5)/5
print(err.aver)