library(CORElearn)
library(frbs)
library(batch)
seed <- 101
set.seed(seed)
## Start input data
load("pima.5f.RData")
tra.pima.1 <- data.frame(pima.5.1.tra)
tra.pima.2 <- data.frame(pima.5.2.tra)
tra.pima.3 <- data.frame(pima.5.3.tra)
tra.pima.4 <- data.frame(pima.5.4.tra)
tra.pima.5 <- data.frame(pima.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9")
colnames(tra.pima.1) <- names.attrs 
colnames(tra.pima.2) <- names.attrs 
colnames(tra.pima.3) <- names.attrs 
colnames(tra.pima.4) <- names.attrs 
colnames(tra.pima.5) <- names.attrs 
							
colnames(pima.5.1.tst) <- names.attrs 
colnames(pima.5.2.tst) <- names.attrs 
colnames(pima.5.3.tst) <- names.attrs 
colnames(pima.5.4.tst) <- names.attrs 
colnames(pima.5.5.tst) <- names.attrs 

real.pima.1 <- data.frame(matrix(pima.5.1.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.2 <- data.frame(matrix(pima.5.2.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.3 <- data.frame(matrix(pima.5.3.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.4 <- data.frame(matrix(pima.5.4.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.5 <- data.frame(matrix(pima.5.5.tst[, ncol(pima.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
object.knn.1 <- CoreModel(c9 ~., tra.pima.1, model = "knn")
object.knn.2 <- CoreModel(c9 ~., tra.pima.2, model = "knn")
object.knn.3 <- CoreModel(c9 ~., tra.pima.3, model = "knn")
object.knn.4 <- CoreModel(c9 ~., tra.pima.4, model = "knn")
object.knn.5 <- CoreModel(c9 ~., tra.pima.5, model = "knn")

pred.1 <- max.col(predict(object.knn.1, data.frame(pima.5.1.tst), type="probability"))
pred.2 <- max.col(predict(object.knn.2, data.frame(pima.5.2.tst), type="probability"))
pred.3 <- max.col(predict(object.knn.3, data.frame(pima.5.3.tst), type="probability"))
pred.4 <- max.col(predict(object.knn.4, data.frame(pima.5.4.tst), type="probability"))
pred.5 <- max.col(predict(object.knn.5, data.frame(pima.5.5.tst), type="probability"))

err.1 = 100*sum(real.pima.1!=pred.1)/length(pred.1)
err.2 = 100*sum(real.pima.2!=pred.2)/length(pred.2)
err.3 = 100*sum(real.pima.3!=pred.3)/length(pred.3)
err.4 = 100*sum(real.pima.4!=pred.4)/length(pred.4)
err.5 = 100*sum(real.pima.5!=pred.5)/length(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)