library(nnet)

library(frbs)
library(batch)
seed <- 101
set.seed(seed)
## Start input data
load("pima.5f.RData")
tra.pima.1 <- data.frame(pima.5.1.tra)
tra.pima.2 <- data.frame(pima.5.2.tra)
tra.pima.3 <- data.frame(pima.5.3.tra)
tra.pima.4 <- data.frame(pima.5.4.tra)
tra.pima.5 <- data.frame(pima.5.5.tra)

target.pima.1 <- class.ind(tra.pima.1[, ncol(tra.pima.1)])
target.pima.2 <- class.ind(tra.pima.2[, ncol(tra.pima.2)])
target.pima.3 <- class.ind(tra.pima.3[, ncol(tra.pima.3)])
target.pima.4 <- class.ind(tra.pima.4[, ncol(tra.pima.4)])
target.pima.5 <- class.ind(tra.pima.5[, ncol(tra.pima.5)])

tst.pima.1 <- data.frame(pima.5.1.tst[, -ncol(pima.5.1.tst)])
tst.pima.2 <- data.frame(pima.5.2.tst[, -ncol(pima.5.1.tst)])
tst.pima.3 <- data.frame(pima.5.3.tst[, -ncol(pima.5.1.tst)])
tst.pima.4 <- data.frame(pima.5.4.tst[, -ncol(pima.5.1.tst)])
tst.pima.5 <- data.frame(pima.5.5.tst[, -ncol(pima.5.1.tst)])

real.pima.1 <- pima.5.1.tst[, ncol(pima.5.1.tst)]
real.pima.2 <- pima.5.2.tst[, ncol(pima.5.1.tst)]
real.pima.3 <- pima.5.3.tst[, ncol(pima.5.1.tst)]
real.pima.4 <- pima.5.4.tst[, ncol(pima.5.1.tst)]
real.pima.5 <- pima.5.5.tst[, ncol(pima.5.1.tst)]


pima.nnet.1 <- nnet(x = tra.pima.1[, -ncol(tra.pima.1)], y = target.pima.1, 
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
pima.nnet.2 <- nnet(x = tra.pima.2[, -ncol(tra.pima.2)], y = target.pima.2, 
					size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
pima.nnet.3 <- nnet(x = tra.pima.3[, -ncol(tra.pima.3)], y = target.pima.3,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
pima.nnet.4 <- nnet(x = tra.pima.4[, -ncol(tra.pima.4)], y = target.pima.4,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
pima.nnet.5 <- nnet(x = tra.pima.5[, -ncol(tra.pima.5)], y = target.pima.5,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)

				
pima.p.1<-predict(pima.nnet.1, tst.pima.1)
pima.p.2<-predict(pima.nnet.2, tst.pima.2)
pima.p.3<-predict(pima.nnet.3, tst.pima.3)
pima.p.4<-predict(pima.nnet.4, tst.pima.4)
pima.p.5<-predict(pima.nnet.5, tst.pima.5)

err.1 = 100*sum(as.numeric(real.pima.1)!=max.col(pima.p.1))/length(real.pima.1)
err.2 = 100*sum(as.numeric(real.pima.2)!=max.col(pima.p.2))/length(real.pima.2)
err.3 = 100*sum(as.numeric(real.pima.3)!=max.col(pima.p.3))/length(real.pima.3)
err.4 = 100*sum(as.numeric(real.pima.4)!=max.col(pima.p.4))/length(real.pima.4)
err.5 = 100*sum(as.numeric(real.pima.5)!=max.col(pima.p.5))/length(real.pima.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 +err.5)/5
print(err.aver)
