library(randomForest)
library(frbs)
library(batch)
seed <- 101
set.seed(seed)
## Start input data
load("pima.5f.RData")
tra.pima.1 <- data.frame(pima.5.1.tra)
tra.pima.2 <- data.frame(pima.5.2.tra)
tra.pima.3 <- data.frame(pima.5.3.tra)
tra.pima.4 <- data.frame(pima.5.4.tra)
tra.pima.5 <- data.frame(pima.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9")
colnames(tra.pima.1) <- names.attrs
colnames(tra.pima.2) <- names.attrs
colnames(tra.pima.3) <- names.attrs
colnames(tra.pima.4) <- names.attrs
colnames(tra.pima.5) <- names.attrs
							

tst.pima.1 <- data.frame(pima.5.1.tst[, -ncol(pima.5.1.tst)])
tst.pima.2 <- data.frame(pima.5.2.tst[, -ncol(pima.5.1.tst)])
tst.pima.3 <- data.frame(pima.5.3.tst[, -ncol(pima.5.1.tst)])
tst.pima.4 <- data.frame(pima.5.4.tst[, -ncol(pima.5.1.tst)])
tst.pima.5 <- data.frame(pima.5.5.tst[, -ncol(pima.5.1.tst)])
names.outattr <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8")
colnames(tst.pima.1) <- names.outattr
colnames(tst.pima.2) <- names.outattr
colnames(tst.pima.3) <- names.outattr
colnames(tst.pima.4) <- names.outattr
colnames(tst.pima.5) <- names.outattr


real.pima.1 <- data.frame(matrix(pima.5.1.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.2 <- data.frame(matrix(pima.5.2.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.3 <- data.frame(matrix(pima.5.3.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.4 <- data.frame(matrix(pima.5.4.tst[, ncol(pima.5.1.tst)], ncol = 1))
real.pima.5 <- data.frame(matrix(pima.5.5.tst[, ncol(pima.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
object.rF.1 <- randomForest(c9 ~., tra.pima.1, importance =TRUE, proximity = TRUE)
object.rF.2 <- randomForest(c9 ~., tra.pima.2, importance =TRUE, proximity = TRUE)
object.rF.3 <- randomForest(c9 ~., tra.pima.3, importance =TRUE, proximity = TRUE)
object.rF.4 <- randomForest(c9 ~., tra.pima.4, importance =TRUE, proximity = TRUE)
object.rF.5 <- randomForest(c9 ~., tra.pima.5, importance =TRUE, proximity = TRUE)

pred.1 <- predict(object.rF.1, tst.pima.1)
pred.2 <- predict(object.rF.2, tst.pima.2)
pred.3 <- predict(object.rF.3, tst.pima.3)
pred.4 <- predict(object.rF.4, tst.pima.4)
pred.5 <- predict(object.rF.5, tst.pima.5)

err.1 = 100*sum(real.pima.1!=round(pred.1))/length(pred.1)
err.2 = 100*sum(real.pima.2!=round(pred.2))/length(pred.2)
err.3 = 100*sum(real.pima.3!=round(pred.3))/length(pred.3)
err.4 = 100*sum(real.pima.4!=round(pred.4))/length(pred.4)
err.5 = 100*sum(real.pima.5!=round(pred.5))/length(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)