library(C50)
library(batch)
seed <- 101
set.seed(seed)
library(frbs)

## Start input data
load("wine.5f.RData")
tra.wine.1 <- data.frame(wine.5.1.tra)
tra.wine.2 <- data.frame(wine.5.2.tra)
tra.wine.3 <- data.frame(wine.5.3.tra)
tra.wine.4 <- data.frame(wine.5.4.tra)
tra.wine.5 <- data.frame(wine.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9", 
						"c10", "c11", "c12", "c13", "c14")
colnames(tra.wine.1) <- names.attrs
colnames(tra.wine.2) <- names.attrs
colnames(tra.wine.3) <- names.attrs
colnames(tra.wine.4) <- names.attrs
colnames(tra.wine.5) <- names.attrs
							

tst.wine.1 <- data.frame(wine.5.1.tst[, -ncol(wine.5.1.tst)])
tst.wine.2 <- data.frame(wine.5.2.tst[, -ncol(wine.5.1.tst)])
tst.wine.3 <- data.frame(wine.5.3.tst[, -ncol(wine.5.1.tst)])
tst.wine.4 <- data.frame(wine.5.4.tst[, -ncol(wine.5.1.tst)])
tst.wine.5 <- data.frame(wine.5.5.tst[, -ncol(wine.5.1.tst)])
names.outatt <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", 
                        "c9", "c10", "c11", "c12", "c13")
colnames(tst.wine.1) <- names.outatt
colnames(tst.wine.2) <- names.outatt
colnames(tst.wine.3) <- names.outatt
colnames(tst.wine.4) <- names.outatt
colnames(tst.wine.5) <- names.outatt


real.wine.1 <- data.frame(matrix(wine.5.1.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.2 <- data.frame(matrix(wine.5.2.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.3 <- data.frame(matrix(wine.5.3.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.4 <- data.frame(matrix(wine.5.4.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.5 <- data.frame(matrix(wine.5.5.tst[, ncol(wine.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
 object.C50.1 <- C5.0(x = tra.wine.1[, -ncol(tra.wine.1)], y = as.factor(tra.wine.1[, ncol(tra.wine.1)]))
 object.C50.2 <- C5.0(x = tra.wine.2[, -ncol(tra.wine.2)], y = as.factor(tra.wine.2[, ncol(tra.wine.2)]))
 object.C50.3 <- C5.0(x = tra.wine.3[, -ncol(tra.wine.3)], y = as.factor(tra.wine.3[, ncol(tra.wine.3)]))
 object.C50.4 <- C5.0(x = tra.wine.4[, -ncol(tra.wine.4)], y = as.factor(tra.wine.4[, ncol(tra.wine.4)]))
 object.C50.5 <- C5.0(x = tra.wine.5[, -ncol(tra.wine.5)], y = as.factor(tra.wine.5[, ncol(tra.wine.5)]))

pred.1 <- matrix(c(predict(object.C50.1, tst.wine.1)))
pred.2 <- matrix(c(predict(object.C50.2, tst.wine.2)))
pred.3 <- matrix(c(predict(object.C50.3, tst.wine.3)))
pred.4 <- matrix(c(predict(object.C50.4, tst.wine.4)))
pred.5 <- matrix(c(predict(object.C50.5, tst.wine.5)))

err.1 = 100*sum(real.wine.1!=pred.1)/nrow(pred.1)
err.2 = 100*sum(real.wine.2!=pred.2)/nrow(pred.2)
err.3 = 100*sum(real.wine.3!=pred.3)/nrow(pred.3)
err.4 = 100*sum(real.wine.4!=pred.4)/nrow(pred.4)
err.5 = 100*sum(real.wine.5!=pred.5)/nrow(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)