library(CORElearn)
library(batch)
seed <- 101
set.seed(seed)
library(frbs)

## Start input data
load("wine.5f.RData")
tra.wine.1 <- data.frame(wine.5.1.tra)
tra.wine.2 <- data.frame(wine.5.2.tra)
tra.wine.3 <- data.frame(wine.5.3.tra)
tra.wine.4 <- data.frame(wine.5.4.tra)
tra.wine.5 <- data.frame(wine.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9", 
						"c10", "c11", "c12", "c13", "c14")
colnames(tra.wine.1) <- names.attrs
colnames(tra.wine.2) <- names.attrs
colnames(tra.wine.3) <- names.attrs
colnames(tra.wine.4) <- names.attrs
colnames(tra.wine.5) <- names.attrs
							
colnames(wine.5.1.tst) <- names.attrs
colnames(wine.5.2.tst) <- names.attrs
colnames(wine.5.3.tst) <- names.attrs
colnames(wine.5.4.tst) <- names.attrs
colnames(wine.5.5.tst) <- names.attrs

real.wine.1 <- data.frame(matrix(wine.5.1.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.2 <- data.frame(matrix(wine.5.2.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.3 <- data.frame(matrix(wine.5.3.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.4 <- data.frame(matrix(wine.5.4.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.5 <- data.frame(matrix(wine.5.5.tst[, ncol(wine.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
object.knn.1 <- CoreModel(c14 ~., tra.wine.1, model = "knn")
object.knn.2 <- CoreModel(c14 ~., tra.wine.2, model = "knn")
object.knn.3 <- CoreModel(c14 ~., tra.wine.3, model = "knn")
object.knn.4 <- CoreModel(c14 ~., tra.wine.4, model = "knn")
object.knn.5 <- CoreModel(c14 ~., tra.wine.5, model = "knn")

pred.1 <- max.col(predict(object.knn.1, data.frame(wine.5.1.tst), type="probability"))
pred.2 <- max.col(predict(object.knn.2, data.frame(wine.5.2.tst), type="probability"))
pred.3 <- max.col(predict(object.knn.3, data.frame(wine.5.3.tst), type="probability"))
pred.4 <- max.col(predict(object.knn.4, data.frame(wine.5.4.tst), type="probability"))
pred.5 <- max.col(predict(object.knn.5, data.frame(wine.5.5.tst), type="probability"))

err.1 = 100*sum(real.wine.1!=pred.1)/length(pred.1)
err.2 = 100*sum(real.wine.2!=pred.2)/length(pred.2)
err.3 = 100*sum(real.wine.3!=pred.3)/length(pred.3)
err.4 = 100*sum(real.wine.4!=pred.4)/length(pred.4)
err.5 = 100*sum(real.wine.5!=pred.5)/length(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)