library(nnet)
library(batch)
seed <- 101
set.seed(seed)
library(frbs)

## Start input data
load("wine.5f.RData")
tra.wine.1 <- data.frame(wine.5.1.tra)
tra.wine.2 <- data.frame(wine.5.2.tra)
tra.wine.3 <- data.frame(wine.5.3.tra)
tra.wine.4 <- data.frame(wine.5.4.tra)
tra.wine.5 <- data.frame(wine.5.5.tra)

target.wine.1 <- class.ind(tra.wine.1[, ncol(tra.wine.1)])
target.wine.2 <- class.ind(tra.wine.2[, ncol(tra.wine.2)])
target.wine.3 <- class.ind(tra.wine.3[, ncol(tra.wine.3)])
target.wine.4 <- class.ind(tra.wine.4[, ncol(tra.wine.4)])
target.wine.5 <- class.ind(tra.wine.5[, ncol(tra.wine.5)])

tst.wine.1 <- data.frame(wine.5.1.tst[, -ncol(wine.5.1.tst)])
tst.wine.2 <- data.frame(wine.5.2.tst[, -ncol(wine.5.1.tst)])
tst.wine.3 <- data.frame(wine.5.3.tst[, -ncol(wine.5.1.tst)])
tst.wine.4 <- data.frame(wine.5.4.tst[, -ncol(wine.5.1.tst)])
tst.wine.5 <- data.frame(wine.5.5.tst[, -ncol(wine.5.1.tst)])

real.wine.1 <- wine.5.1.tst[, ncol(wine.5.1.tst)]
real.wine.2 <- wine.5.2.tst[, ncol(wine.5.1.tst)]
real.wine.3 <- wine.5.3.tst[, ncol(wine.5.1.tst)]
real.wine.4 <- wine.5.4.tst[, ncol(wine.5.1.tst)]
real.wine.5 <- wine.5.5.tst[, ncol(wine.5.1.tst)]


wine.nnet.1 <- nnet(x = tra.wine.1[, -ncol(tra.wine.1)], y = target.wine.1, 
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
wine.nnet.2 <- nnet(x = tra.wine.2[, -ncol(tra.wine.2)], y = target.wine.2, 
					size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
wine.nnet.3 <- nnet(x = tra.wine.3[, -ncol(tra.wine.3)], y = target.wine.3,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
wine.nnet.4 <- nnet(x = tra.wine.4[, -ncol(tra.wine.4)], y = target.wine.4,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)
wine.nnet.5 <- nnet(x = tra.wine.5[, -ncol(tra.wine.5)], y = target.wine.5,
                    size = 5, rang = 0.8, decay = 5e-4, maxit = 1000)

				
wine.p.1<-predict(wine.nnet.1, tst.wine.1)
wine.p.2<-predict(wine.nnet.2, tst.wine.2)
wine.p.3<-predict(wine.nnet.3, tst.wine.3)
wine.p.4<-predict(wine.nnet.4, tst.wine.4)
wine.p.5<-predict(wine.nnet.5, tst.wine.5)

err.1 = 100*sum(as.numeric(real.wine.1)!=max.col(wine.p.1))/length(real.wine.1)
err.2 = 100*sum(as.numeric(real.wine.2)!=max.col(wine.p.2))/length(real.wine.2)
err.3 = 100*sum(as.numeric(real.wine.3)!=max.col(wine.p.3))/length(real.wine.3)
err.4 = 100*sum(as.numeric(real.wine.4)!=max.col(wine.p.4))/length(real.wine.4)
err.5 = 100*sum(as.numeric(real.wine.5)!=max.col(wine.p.5))/length(real.wine.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 +err.5)/5
print(err.aver)
