library(randomForest)
library(batch)
seed <- 101
set.seed(seed)
library(frbs)

## Start input data
load("wine.5f.RData")
tra.wine.1 <- data.frame(wine.5.1.tra)
tra.wine.2 <- data.frame(wine.5.2.tra)
tra.wine.3 <- data.frame(wine.5.3.tra)
tra.wine.4 <- data.frame(wine.5.4.tra)
tra.wine.5 <- data.frame(wine.5.5.tra)
names.attrs <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9", 
						"c10", "c11", "c12", "c13", "c14")
colnames(tra.wine.1) <- names.attrs
colnames(tra.wine.2) <- names.attrs
colnames(tra.wine.3) <- names.attrs
colnames(tra.wine.4) <- names.attrs
colnames(tra.wine.5) <- names.attrs
							

tst.wine.1 <- data.frame(wine.5.1.tst[, -ncol(wine.5.1.tst)])
tst.wine.2 <- data.frame(wine.5.2.tst[, -ncol(wine.5.1.tst)])
tst.wine.3 <- data.frame(wine.5.3.tst[, -ncol(wine.5.1.tst)])
tst.wine.4 <- data.frame(wine.5.4.tst[, -ncol(wine.5.1.tst)])
tst.wine.5 <- data.frame(wine.5.5.tst[, -ncol(wine.5.1.tst)])
names.outattr <- c("c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", 
                        "c9", "c10", "c11", "c12", "c13")
colnames(tst.wine.1) <- names.outattr
colnames(tst.wine.2) <- names.outattr
colnames(tst.wine.3) <- names.outattr
colnames(tst.wine.4) <- names.outattr
colnames(tst.wine.5) <- names.outattr


real.wine.1 <- data.frame(matrix(wine.5.1.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.2 <- data.frame(matrix(wine.5.2.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.3 <- data.frame(matrix(wine.5.3.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.4 <- data.frame(matrix(wine.5.4.tst[, ncol(wine.5.1.tst)], ncol = 1))
real.wine.5 <- data.frame(matrix(wine.5.5.tst[, ncol(wine.5.1.tst)], ncol = 1))

## generate model using classification tree with default parameters (for simplicity).
object.rF.1 <- randomForest(c14 ~., tra.wine.1, importance =TRUE, proximity = TRUE)
object.rF.2 <- randomForest(c14 ~., tra.wine.2, importance =TRUE, proximity = TRUE)
object.rF.3 <- randomForest(c14 ~., tra.wine.3, importance =TRUE, proximity = TRUE)
object.rF.4 <- randomForest(c14 ~., tra.wine.4, importance =TRUE, proximity = TRUE)
object.rF.5 <- randomForest(c14 ~., tra.wine.5, importance =TRUE, proximity = TRUE)

pred.1 <- predict(object.rF.1, tst.wine.1)
pred.2 <- predict(object.rF.2, tst.wine.2)
pred.3 <- predict(object.rF.3, tst.wine.3)
pred.4 <- predict(object.rF.4, tst.wine.4)
pred.5 <- predict(object.rF.5, tst.wine.5)

err.1 = 100*sum(real.wine.1!=round(pred.1))/length(pred.1)
err.2 = 100*sum(real.wine.2!=round(pred.2))/length(pred.2)
err.3 = 100*sum(real.wine.3!=round(pred.3))/length(pred.3)
err.4 = 100*sum(real.wine.4!=round(pred.4))/length(pred.4)
err.5 = 100*sum(real.wine.5!=round(pred.5))/length(pred.5)

err.aver <- (err.1 + err.2 + err.3 + err.4 + err.5)/5
print("average error")
print(err.aver)