library(frbs)
library(batch)
seed <- 101
parseCommandArgs()
set.seed(seed)
library(frbs)
library(nnet)

## Input data
data(frbsData)
frbsData$MackeyGlass1000.dt <- frbsData$MackeyGlass1000.dt[sample(nrow(frbsData$MackeyGlass1000.dt)), ]
data.train <- frbsData$MackeyGlass1000.dt[1: 500, ]
data.fit <- data.train[, 1 : 4]
data.tst <- frbsData$MackeyGlass1000.dt[501 : 1000, 1 : 4]
real.val <- matrix(frbsData$MackeyGlass1000.dt[501 : 1000, 5], ncol = 1)
range.data<-matrix(c(0.43462, 1.3105, 0.43462, 1.3105, 0.43462, 1.3105, 0.43462, 1.3105, 0.43462, 1.3105), nrow=2)


nnet.MG <- nnet(x = data.train[, -ncol(data.train)], y = data.train[, ncol(data.train)], 
                    size = 30, linout = TRUE, maxit = 1000)
				
pred <- predict(nnet.MG, data.tst)


benchmark <- cbind(real.val, pred)

colnames(benchmark) <- c("real", "tree")
print(benchmark)
residuals <- (real.val - pred)
MSE <- mean(residuals^2)
RMSE <- sqrt(mean(residuals^2))
SMAPE <- mean(abs(residuals)/(abs(real.val) + abs(pred))/2)*100
err <- c(MSE, RMSE, SMAPE)
names(err) <- c("MSE", "RMSE", "SMAPE")
print("Error Measurement: ")
print(err) 
